#include "targetver.h"
#include <windows.h>
#include <iostream>
#include <tchar.h>
#include <assert.h>
#include <string>
#include <vector>
#include <list>

using namespace std;

class Timing {
public:
  void StartTiming();
  void StopTiming();
  double GetUserSeconds() const {
    return value;
  }
private:
  DWORD_PTR oldmask;
  double value;
  LARGE_INTEGER time1;
};

void Timing::StartTiming()
{         
  oldmask = SetThreadAffinityMask(::GetCurrentThread(), 1);

  volatile size_t warmingUp = 1;
	for (size_t i=1; i<100000; i++)
		warmingUp *= i;

  QueryPerformanceCounter(&time1);
}  

void Timing::StopTiming()
{  
  LARGE_INTEGER performance_frequency, time2;
  QueryPerformanceFrequency(&performance_frequency);
  QueryPerformanceCounter(&time2);  
  SetThreadAffinityMask(::GetCurrentThread(), oldmask);
  value = (double)(time2.QuadPart - time1.QuadPart);
  value /= performance_frequency.QuadPart;
}  

size_t Foo1(const std::vector<size_t> &arr)
{
  size_t sum = 0;
  std::vector<size_t>::const_iterator it;
  for (it = arr.begin(); it != arr.end(); it++)
    sum += *it;
  return sum;
}

size_t Foo2(const std::vector<size_t> &arr)
{
  size_t sum = 0;
  std::vector<size_t>::const_iterator it;
  for (it = arr.begin(); it != arr.end(); ++it)
    sum += *it;
  return sum;
}

size_t Foo1_size_t(const std::vector<size_t> &arr)
{
  size_t sum = 0;
  for (size_t i = 0; i != arr.size(); i++)
    sum += arr[i];
  return sum;
}

size_t Foo2_size_t(const std::vector<size_t> &arr)
{
  size_t sum = 0;
  for (size_t i = 0; i != arr.size(); ++i)
    sum += arr[i];
  return sum;
}

int _tmain(int argc, _TCHAR* argv[])
{
  int nRetCode = 0; 
  try {
    std::vector<size_t> arr;
    for (size_t i = 0; i != 33333; ++i)
      arr.push_back(i + 1);

    size_t x;
    Timing metric;

    const size_t Count = 5000;

    x = 0;
    metric.StartTiming();
	  for (size_t i = 0; i != Count; ++i)
      x += Foo1(arr);
    metric.StopTiming();
    cout << "x = " << x << endl;
    cout << "iterator++. Total time : " << metric.GetUserSeconds() << endl;

    x = 0;
    metric.StartTiming();
	  for (size_t i = 0; i != Count; ++i)
	    x += Foo2(arr);
    metric.StopTiming();
    cout << "x = " << x << endl;
    cout << "++iterator. Total time : " << metric.GetUserSeconds() << endl;

    x = 0;
    metric.StartTiming();
	  for (size_t i = 0; i != Count; ++i)
      x += Foo1_size_t(arr);
    metric.StopTiming();
    cout << "x = " << x << endl;
    cout << "size_t. iterator++. Total time : " << metric.GetUserSeconds() << endl;

    x = 0;
    metric.StartTiming();
	  for (size_t i = 0; i != Count; ++i)
	    x += Foo2_size_t(arr);
    metric.StopTiming();
    cout << "x = " << x << endl;
    cout << "size_t. ++iterator. Total time : " << metric.GetUserSeconds() << endl;
  }

  catch (...) {
    cout << "Fatal Error: some exception..." << endl;
    nRetCode = 1;
  }
  return nRetCode;
}

